<?php if (!defined('APPLICATION')) exit();
/*Copyright 2014 Zachary Doll */
$PluginInfo['MarkV'] = array(
	'Name' => 'Mark V',
	'Description' => 'Allows user to mark a comment as a V.',
	'Version' => '0.1',
	'MobileFriendly' => TRUE,
  'Author' => 'Zachary Doll',
	'AuthorEmail' => 'hgtonight@daklutz.com',
	'AuthorUrl' => 'http://www.daklutz.com',
	'License' => 'GPLv3'
);

class MarkVPlugin extends Gdn_Plugin {

  public function DiscussionController_CommentInfo_Handler($Sender) {
    $this->AddMarkV($Sender);
  }

  protected function AddMarkV($Sender) {
    $Discussion = $Sender->EventArguments['Discussion'];
    $Session = Gdn::Session();
    $Comment = $Sender->EventArguments['Comment'];
      if($Session->UserID == $Discussion->InsertUserID || $Session->CheckPermission('Garden.Moderation.Manage')) {
      if ($Comment->MarkV) {
        echo Anchor("&#10004;", 'discussion/markv/' . $Comment->CommentID, 'Hijack img-swap on');
      }
      else {
        echo Anchor("&#10004;", 'discussion/markv/' . $Comment->CommentID, 'Hijack img-swap');
      }
    }
    else {
      if ($Comment->MarkV) {
        echo Wrap("&#10004;", 'div', array('class' => 'Hijack img-swap on'));
      }
      else {
        echo Wrap("&#10004;", 'div', array('class' => 'Hijack img-swap'));
      }
    }
  }

  public function DiscussionController_Render_Before($Sender) {
    $Sender->AddJsFile($this->GetResource('js/markv.js', FALSE, FALSE));
    $Sender->AddCssFile($this->GetResource('design/markv.css', FALSE, FALSE));
  }
  
  public function DiscussionController_MarkV_Create($Sender, $Args) {
    // Make sure the user is allowed to mark this comment    
    $Comment = $Sender->CommentModel->GetID($Args[0]);
    $Discussion = $Sender->DiscussionModel->GetID($Comment->DiscussionID);
    $Session = Gdn::Session();
    if($Session->UserID == $Discussion->InsertUserID || $Session->CheckPermission('Garden.Moderation.Manage')) {
      $Sender->CommentModel->SetField($Comment->CommentID, 'MarkV', !$Comment->MarkV);
      
      if(!$Sender->Request->IsPostBack()) {
        Redirect('/discussion/' . $Comment->DiscussionID);
      }
      else {
        $Sender->InformMessage('Mark Updated');
        // Don't render anything
        $Sender->Render('Blank', 'Utility', 'Dashboard');
      }
    }
    
    
  }

  public function Structure() {
    $Structure = Gdn::Structure();
    $Structure->Table('Comment')
      ->Column('MarkV', 'tinyint', 0)
      ->Set();
  }

	public function Setup() {
    $this->Structure();
	}
}
